#!/usr/bin/python3

import sys
import os
from os.path import isfile, join, basename
from debian import copyright
import argparse
import json
import gzip

DEFAULT_BOM_DIR = '/usr/share/doc'
COPYRIGHT_REPORT = 'copyright_report'
COPYRIGHT_REPORT_GZ = COPYRIGHT_REPORT + '.gz'

VERBOSE_IMAGE = 0
VERBOSE_PACKAGE = 1
VERBOSE_BINARY = 2
VERBOSE_SOURCE = 3

PROBLEMATIC_LICENSES = ['GPL-3', 'GPL-3+', 'AGPL-3', 'AGPL-3+', 'AGPL-1', 'AGPL-1+', 'LGPL-3', 'LGPL-3+', 'BSD-4-Clause', 'MPL-1.1']

global_args = None

def get_global_args():
    global global_args

    return global_args

def set_global_args(args):
    global global_args

    global_args = args

def get_no_license_report_found_str():
    return 'NoLicenseReportFound'

def get_no_license_info_found_str():
    return 'NoLicenseInfoFound'

def get_license_str(paragraph):
    license =  paragraph.license[0]
    if get_global_args().comments:
        license += ' ' + str(paragraph.comment)

    return license

# Get the license for file by searching the exact file path
def get_copyright_license(copyright_info, f_src):
    p = copyright_info.find_files_paragraph(f_src)
    if p != None:
        return get_license_str(p)

    return get_no_license_info_found_str()

# Get the license for file by searching a match with the last part
# of the report generated by FOSSolgy as we can't rely on the folder
# used to upload the source code
def get_copyright_license_relaxed(copyright_info, f_src):
    for p in copyright_info.all_files_paragraphs():
        for f in p.files:
            if f.endswith(f_src):
                return get_license_str(p)

    return get_no_license_info_found_str()

def get_copyright_file(filenames):
    if COPYRIGHT_REPORT in filenames:
        return COPYRIGHT_REPORT
    if COPYRIGHT_REPORT_GZ in filenames:
        return COPYRIGHT_REPORT_GZ

    return None

def get_base_package_name(dirpath):
    return basename(dirpath)

def get_package_name(fn_binaries):
    return basename(fn_binaries).replace('_bin2sources.json', '')

def scan_units(binary_name, copyright_info, units, verbose):
    binary_licenses = set()
    sources = []

    if not copyright_info:
        return {'binary_name': binary_name, 'binary_licenses': [get_no_license_report_found_str()], 'sources': sources}

    for un in units:
        f_src =  un['comp_name']
        f_dir = un['comp_dir']
        # Avoid processing no real entries that can be produced by dwarf2sources
        # when using lto optimization
        if f_src == '<artificial>':
            continue

        if f_src.startswith('../'):
            f_src = f_src[3:]
        elif f_dir != './' and f_dir != '.':
            f_src = join(f_dir, f_src)

        if not get_global_args().relaxed:
            license = get_copyright_license(copyright_info, f_src)
        else:
            license = get_copyright_license_relaxed(copyright_info, f_src)
        if verbose > VERBOSE_BINARY:
            sources.append({'source': f_src, 'license': str(license)})
        binary_licenses.add(license)

    return {'binary_name': binary_name, 'binary_licenses': list(binary_licenses), 'sources': sources}

def check_binaries_copyright(package_name, fn_copyright, fn_binaries, verbose):
    copyright_info = None
    package_licenses = set()
    binaries = []

    if fn_copyright:
        if fn_copyright.endswith('.gz'):
            f_copyright = gzip.open(fn_copyright)
        else:
            f_copyright = open(fn_copyright)
        try:
            copyright_info = copyright.Copyright(f_copyright, strict=False)
        except:
            print(f'WARNING package {package_name} tries to use invalid copyright file {fn_copyright}', file=sys.stderr)

    if fn_binaries.endswith('.gz'):
        f_binaries = gzip.open(fn_binaries)
    else:
        f_binaries = open(fn_binaries)

    binaries_info = json.load(f_binaries)

    for binary_name in binaries_info:
        binary = scan_units(binary_name, copyright_info, binaries_info[binary_name]['units'], verbose)
        if verbose > VERBOSE_PACKAGE:
            binaries.append(binary)

        package_licenses.update(binary['binary_licenses'])

    problematic = package_licenses.intersection(PROBLEMATIC_LICENSES)
    if problematic:
        print(f'WARNING package {package_name} contains at least a problematic license', file=sys.stderr)

    return {'package_name': package_name, 'package_licenses': list(package_licenses), 'binaries': binaries}

def check_packages_copyright(bom_dir, verbose, pretty):
    image_licenses = set()
    packages = []

    for (dirpath, dirnames, filenames) in os.walk(bom_dir):
            if len(filenames) == 0:
                continue
            base_package_name = get_base_package_name(dirpath)
            fn_copyright = get_copyright_file(filenames)
            if fn_copyright:
                fn_copyright = join(dirpath , fn_copyright)
            for f in filenames:
                if not isfile(join(dirpath , f)) or not (f.endswith('_bin2sources.json') or f.endswith('_bin2sources.json.gz')):
                    continue

                f = join(dirpath, f)

                package_name = get_package_name(f)
                package = check_binaries_copyright(package_name, fn_copyright, f, verbose)
                if verbose > VERBOSE_IMAGE:
                    packages.append(package)

                image_licenses.update(package['package_licenses'])

    image = {'image_licenses': list(image_licenses), 'packages': packages}

    kwargs = {}
    if pretty:
        kwargs["indent"] = 4
    print(json.dumps(image, **kwargs))

def main(argv):
    global RELAXED_SEARCH

    parser = argparse.ArgumentParser()
    parser.add_argument ("-c","--comments", action='store_true', help="include license comments")
    parser.add_argument ("-d","--dir", default=DEFAULT_BOM_DIR, help="directory to search for information")
    parser.add_argument ("-p","--pretty", action='store_true', help="indent the JSON output")
    parser.add_argument ("-r","--relaxed", action='store_true', help="use relaxed search")
    parser.add_argument ("-v","--verbose", type=int, default=VERBOSE_IMAGE, help="verbose use in output 0: image, 1: package, 2: binary, 3: source")
    args = parser.parse_args ()

    set_global_args(args)

    check_packages_copyright(args.dir, args.verbose, args.pretty)

if __name__ == '__main__':
    main(sys.argv[1:])
